package de.snailshell.consensus.demo.actions;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import de.snailshell.consensus.demo.Constants;
import de.uka.ipd.consensus.foundation.query.QueryEngine;

/**
 * @author Thomas Much
 * @version 2006-06-14
 */
public class TopicSearchAction extends BasisAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		if (!isUserLoggedOn(request)) {
			return mapping.findForward( Constants.MAPPING_FAILURE );			
		}

		String search = ((DynaActionForm)form).getString("suchbegriff");
		String where  = ((DynaActionForm)form).getString("wo");

		boolean searchComment = where.equalsIgnoreCase("auchbeschreibung");

		QueryEngine queryEngine = this.getOntologyManager().getQueryEngine();
		
		Collection liste = queryEngine.getTopicsBySubstring( this.getUser(request), search, searchComment );
		
		request.setAttribute(Constants.REQUEST_ATTR_TOPICSEARCH, search);
		request.setAttribute(Constants.REQUEST_ATTR_TOPICS, liste);

		return mapping.findForward( Constants.MAPPING_SUCCESS );
	}
}
